---
title: <custom-ident>
slug: Web/CSS/custom-ident
tags:
  - CSS
  - CSS Data Type
  - Data Type
  - Layout
  - Reference
  - Web
---
<div>{{CSSRef}}</div>

<p>The <strong><code>&lt;custom-ident&gt;</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Types">data type</a> denotes an arbitrary user-defined string used as an {{glossary("identifier")}}. It is case-sensitive, and certain values are forbidden in various contexts to prevent ambiguity.</p>

<h2 id="Syntax">Syntax</h2>

<p>The syntax of <code>&lt;custom-ident&gt;</code> is similar to CSS identifiers (such as property names), except that it is <a class="external" href="http://en.wikipedia.org/wiki/Case_sensitivity">case-sensitive</a>. It consists of one or more characters, where characters can be any of the following:</p>

<ul>
 <li>any alphabetical character (<code>A</code> to <code>Z</code>, or <code>a</code> to <code>z</code>),</li>
 <li>any decimal digit (<code>0</code> to <code>9</code>),</li>
 <li>a hyphen (<code>-</code>),</li>
 <li>an underscore (<code>_</code>),</li>
 <li>an escaped character (preceded by a backslash, <code>\</code>),</li>
 <li>a <a class="external" href="http://en.wikipedia.org/wiki/Unicode">Unicode</a> character (in the format of a backslash, <code>\</code>, followed by one to six hexadecimal digits, representing its Unicode code point)</li>
</ul>

<p>Note that <code>id1</code>, <code>Id1</code>, <code>iD1</code> and <code>ID1</code> are all different identifiers as they are <a class="external" href="http://en.wikipedia.org/wiki/Case_sensitivity">case-sensitive</a>. On the other hand, as there are several ways to escape a character, <code>toto\?</code> and <code>toto\3F</code> are the same identifiers.</p>

<h3 id="Forbidden_values">Forbidden values</h3>

<p>A <code>&lt;custom-ident&gt;</code> must not be placed between single or double quotes as this would be identical to a {{CSSxRef("&lt;string&gt;")}}. Moreover, the first character must not be a decimal digit, nor a hyphen (<code>-</code>) followed by a decimal digit or another hyphen.</p>

<p>To prevent ambiguity, each property that uses <code>&lt;custom-ident&gt;</code> forbids the use of specific values:</p>

<dl>
 <dt>{{CSSxRef("animation-name")}}</dt>
 <dd>Forbids the global CSS values (<code>unset</code>, <code>initial</code>, and <code>inherit</code>), as well as <code>none</code>.</dd>
 <dt>{{CSSxRef("counter-reset")}}</dt>
 <dt>{{CSSxRef("counter-increment")}}</dt>
 <dd>Forbids the global CSS values (<code>unset</code>, <code>initial</code>, and <code>inherit</code>), as well as <code>none</code>.</dd>
 <dt>{{CSSxRef("@counter-style")}}</dt>
 <dt>{{CSSxRef("list-style-type")}}</dt>
 <dd>Forbids the global CSS values (<code>unset</code>, <code>initial</code>, and <code>inherit</code>), as well as the values <code>none</code>, <code>inline</code>, and <code>outside</code>. Also, quite a few predefined values are implemented by the different browsers: <code>disc</code>, <code>circle</code>, <code>square</code>, <code>decimal</code>, <code>cjk-decimal</code>, <code>decimal-leading-zero</code>, <code>lower-roman</code>, <code>upper-roman</code>, <code>lower-greek</code>, <code>lower-alpha</code>, <code>lower-latin</code>, <code>upper-alpha</code>, <code>upper-latin</code>, <code>arabic-indic</code>, <code>armenian</code>, <code>bengali</code>, <code>cambodian</code>, <code>cjk-earthly-branch</code>, <code>cjk-heavenly-stem</code>, <code>cjk-ideographic</code>, <code>devanagari</code>, <code>ethiopic-numeric</code>, <code>georgian</code>, <code>gujarati</code>, <code>gurmukhi</code>, <code>hebrew</code>, <code>hiragana</code>, <code>hiragana-iroha</code>, <code>japanese-formal</code>, <code>japanese-informal</code>, <code>kannada</code>, <code>katakana</code>, <code>katakana-iroha</code>, <code>khmer</code>, <code>korean-hangul-formal</code>, <code>korean-hanja-formal</code>, <code>korean-hanja-informal</code>, <code>lao</code>, <code>lower-armenian</code>, <code>malayalam</code>, <code>mongolian</code>, <code>myanmar</code>, <code>oriya</code>, <code>persian</code>, <code>simp-chinese-formal</code>, <code>simp-chinese-informal</code>, <code>tamil</code>, <code>telugu</code>, <code>thai</code>, <code>tibetan</code>, <code>trad-chinese-formal</code>, <code>trad-chinese-informal</code>, <code>upper-armenian</code>, <code>disclosure-open</code>, and <code>disclosure-close</code>.</dd>
 <dt>{{CSSxRef("grid-row-start")}}<br>
 {{CSSxRef("grid-row-end")}}<br>
 {{CSSxRef("grid-column-start")}}<br>
 {{CSSxRef("grid-column-end")}}</dt>
 <dd>Forbids the <code>span</code> value.</dd>
 <dt>{{CSSxRef("will-change")}}</dt>
 <dd>Forbids the global CSS values (<code>unset</code>, <code>initial</code>, and <code>inherit</code>), as well as the values <code>will-change</code>, <code>auto</code>, <code>scroll-position</code>, and <code>contents</code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Valid_identifiers">Valid identifiers</h3>

<pre class="notranslate">nono79            A mix of alphanumeric characters and numbers
ground-level      A mix of alphanumeric characters and a dash
-test             A dash followed by alphanumeric characters
_internal         An underscore followed by alphanumeric characters
\22 toto          A Unicode character followed by a sequence of alphanumeric characters
bili\.bob         A correctly escaped period
</pre>

<h3 id="Invalid_identifiers">Invalid identifiers</h3>

<pre class="example-bad notranslate">34rem             It must not start with a decimal digit.
-12rad            It must not start with a dash followed by a decimal digit.
bili.bob          Only alphanumeric characters, _, and - needn't be escaped.
--toto            It must not start with two dashes. This would be a custom property.
'bilibob'         This would be a &lt;string&gt;.
"bilibob"         This would be a &lt;string&gt;.</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS4 Values', '#custom-idents', '<code>&lt;custom-ident&gt;</code>')}}</td>
   <td>{{Spec2('CSS4 Values')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('CSS Will Change', '#valdef-will-change-custom-ident', '<code>&lt;custom-ident&gt;</code> for <code>will-change</code>')}}</td>
   <td>{{Spec2('CSS Will Change')}}</td>
   <td>Defines which values are excluded for {{CSSxRef("will-change")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Counter Styles', '#typedef-counter-style-name', '<code>&lt;custom-ident&gt;</code> for <code>list-style-type</code>')}}</td>
   <td>{{Spec2('CSS3 Counter Styles')}}</td>
   <td>Uses <code>&lt;custom-ident&gt;</code> instead of a finite list of keywords. Defines which values are excluded for {{CSSxRef("list-style-type")}} and {{CSSxRef("@counter-style")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Lists', '#counter-properties', '<code>&lt;custom-ident&gt;</code> for <code>counter-*</code>')}}</td>
   <td>{{Spec2('CSS3 Lists')}}</td>
   <td>Renames <code>&lt;identifier&gt;</code> to <code>&lt;custom-ident&gt;</code>. Adds its usage to the new <code>counter-set</code> property.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Animations', '#typedef-single-animation-name', '<code>&lt;custom-ident&gt;</code> for <code>animation-name</code>')}}</td>
   <td>{{Spec2('CSS3 Animations')}}</td>
   <td>Defines which values are excluded for {{CSSxRef("animation-name")}}.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Values', '#custom-idents', '<code>&lt;custom-ident&gt;</code>')}}</td>
   <td>{{Spec2('CSS3 Values')}}</td>
   <td>Renames <code>&lt;identifier&gt;</code> to <code>&lt;custom-ident&gt;</code>. Makes it a pseudo-type and forbids the use of excluded values.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS2.1', 'syndata.html#value-def-identifier', '<code>&lt;identifier&gt;</code>')}}</td>
   <td>{{Spec2('CSS2.1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p><em>As this type is not a real type but a convenience type used to simplify the description of allowed values, there is no browser compatibility information as such.</em></p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef("&lt;ident&gt;")}}</li>
</ul>
